#pragma once
#include <iomanip>
#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <cmath>
#include <cstdlib>

#include "math/matrix.hh"
#include "commons.hh"

using namespace std;



namespace HELL {

  extern void SetRCmodeCF(unsigned int mode=0);  // mode=0 uses gammadot, mode=1 uses as*beta0
  extern void SetRCvarCF (bool var);  // var=true uses "Airy" anomalous dimension

  extern dcomplex DeltaCtest1Res(dcomplex Delta_gammaLO_BatNLO, dcomplex Delta_gammaLOdot_BatNLO, dcomplex N, double as, double nf, dcomplex Delta_gammaNLO=0, void *pars=NULL);
  extern dcomplex DeltaCtest2Res(dcomplex Delta_gammaLO_BatNLO, dcomplex Delta_gammaLOdot_BatNLO, dcomplex N, double as, double nf, dcomplex Delta_gammaNLO=0, void *pars=NULL);
  extern dcomplex newDeltaGammaResNLOqg(dcomplex Delta_gammaLO_BatNLO, dcomplex Delta_gammaLOdot_BatNLO, dcomplex N, double as, double nf, dcomplex Delta_gammaNLO=0, void *pars=NULL);
  //
  extern dcomplex DeltaCLRes (dcomplex Delta_gammaLO_BatNLO, dcomplex Delta_gammaLOdot_BatNLO, dcomplex N, double as, double nf, dcomplex Delta_gammaNLO=0, void *pars=NULL);
  extern dcomplex DeltaC2Res (dcomplex Delta_gammaLO_BatNLO, dcomplex Delta_gammaLOdot_BatNLO, dcomplex N, double as, double nf, dcomplex Delta_gammaNLO=0, void *pars=NULL);
  extern dcomplex DeltaKhgRes(dcomplex Delta_gammaLO_BatNLO, dcomplex Delta_gammaLOdot_BatNLO, dcomplex N, double as, double nf, dcomplex Delta_gammaNLO=0, void *pars=NULL);
  extern dcomplex DeltaMCLRes(dcomplex Delta_gammaLO_BatNLO, dcomplex Delta_gammaLOdot_BatNLO, dcomplex N, double as, double nf, dcomplex Delta_gammaNLO=0, void *pars=NULL);
  extern dcomplex DeltaMC2Res(dcomplex Delta_gammaLO_BatNLO, dcomplex Delta_gammaLOdot_BatNLO, dcomplex N, double as, double nf, dcomplex Delta_gammaNLO=0, void *pars=NULL);
  extern dcomplex DeltaMCLResAxial(dcomplex Delta_gammaLO_BatNLO, dcomplex Delta_gammaLOdot_BatNLO, dcomplex N, double as, double nf, dcomplex Delta_gammaNLO=0, void *pars=NULL);
  extern dcomplex DeltaMC2ResAxial(dcomplex Delta_gammaLO_BatNLO, dcomplex Delta_gammaLOdot_BatNLO, dcomplex N, double as, double nf, dcomplex Delta_gammaNLO=0, void *pars=NULL);
  extern dcomplex DeltaMCLResCC(dcomplex Delta_gammaLO_BatNLO, dcomplex Delta_gammaLOdot_BatNLO, dcomplex N, double as, double nf, dcomplex Delta_gammaNLO=0, void *pars=NULL);
  extern dcomplex DeltaMC2ResCC(dcomplex Delta_gammaLO_BatNLO, dcomplex Delta_gammaLOdot_BatNLO, dcomplex N, double as, double nf, dcomplex Delta_gammaNLO=0, void *pars=NULL);
  extern dcomplex DeltaMC3ResCC(dcomplex Delta_gammaLO_BatNLO, dcomplex Delta_gammaLOdot_BatNLO, dcomplex N, double as, double nf, dcomplex Delta_gammaNLO=0, void *pars=NULL);
  //
  extern dcomplex DeltaHggRes   (dcomplex Delta_gammaLO_BatNLO, dcomplex Delta_gammaLOdot_BatNLO, dcomplex N, double as, double nf, dcomplex Delta_gammaNLO=0, void *pars=NULL);
  extern dcomplex DeltaHggAuxRes(dcomplex Delta_gammaLO_BatNLO, dcomplex Delta_gammaLOdot_BatNLO, dcomplex N, double as, double nf, dcomplex Delta_gammaNLO=0, void *pars=NULL);

  extern dcomplex integrand(double xi, dcomplex N, dcomplex gamma, dcomplex r, process p, double x1, void *par=NULL);
  extern dcomplex evolU(double xi, dcomplex g, dcomplex r);
  extern dcomplex Dxi_evolU(double xi, dcomplex g, dcomplex r);
  extern dcomplex integrandGSL(double x, void *p);
  extern double Dxi_C2off(double xi);

};

